CodeForces 499D. Name That Tune(概率dp)

It turns out that you are a great fan of rock band AC/PE. Peter learned that and started the following game: he plays the first song of the list of n songs of the group, and you have to find out the name of the song. After you tell the song name, Peter immediately plays the following song in order, and so on.

The i-th song of AC/PE has its recognizability pi. This means that if the song has not yet been recognized by you, you listen to it for exactly one more second and with probability of pi percent you recognize it and tell it's name. Otherwise you continue listening it. Note that you can only try to guess it only when it is integer number of seconds after the moment the song starts playing.

In all AC/PE songs the first words of chorus are the same as the title, so when you've heard the first ti seconds of i-th song and its chorus starts, you immediately guess its name for sure.

For example, in the song Highway To Red the chorus sounds pretty late, but the song has high recognizability. In the song Back In Blue, on the other hand, the words from the title sound close to the beginning of the song, but it's hard to name it before hearing those words. You can name both of these songs during a few more first seconds.

Determine the expected number songs of you will recognize if the game lasts for exactly T seconds (i. e. you can make the last guess on the second T, after that the game stops).

If all songs are recognized faster than in T seconds, the game stops after the last song is recognized.

Input

The first line of the input contains numbers n and T (1 ≤ n ≤ 5000, 1 ≤ T ≤ 5000), separated by a space. Next n lines contain pairs of numbers pi and ti (0 ≤ pi ≤ 100, 1 ≤ ti ≤ T). The songs are given in the same order as in Petya's list.

Output

Output a single number — the expected number of the number of songs you will recognize in T seconds. Your answer will be considered correct if its absolute or relative error does not exceed 10 - 6.

Examples
input
Copy
2 2
50 2
10 1
output
Copy
1.500000000
input
Copy
2 2
0 2
100 2
output
Copy
1.000000000
input
Copy
3 3
50 3
50 2
25 2
output
Copy
1.687500000
input
Copy
2 2
0 2
0 2
output
Copy
1.000000000

题意:给出n首歌,每首歌长度为t[i]分钟,在歌曲播放的每分钟里都有p[i]的概率猜出歌名,如果猜出就会跳下一首,否则等这首歌放完了也会切下一首,求T秒时听歌数的期望。
题解:令dp[i][j]表示第j分钟恰好听出第i首歌的概率,那么答案就是所有的dp[i][j](i<=n,j<=t)之和
考虑转移:
这首歌在第j秒听完的概率只会从他之前t[i]秒转移过来,所以dp的转移如下
dp[i][j]=∑(dp[i-1][j-k]*(1-p[i])^(k-1)*p[i]
)+dp[i][j-t[i]]*(1-p[i])^(t[i]-1)(k<t[i]);

代码如下:
#include<set>
#include<map>
#include<cmath>
#include<queue>
#include<stack>
#include<vector>
#include<cstdio>
#include<string>
#include<cstring>
#include<iostream>
#include<algorithm>
using namespace std;

double dp[5050][5050],p[5050];
int n,t,tt[5050];

double kasumi(double a,int b)
{
    double ans=1.0;
    while(b)
    {
        if(b&1)
        {
            ans=ans*a;
        }
        a=a*a;
        b>>=1;
    }
    return ans;
}

int main()
{
    scanf("%d%d",&n,&t);
    for(int i=1;i<=n;i++)
    {
        scanf("%lf%d",&p[i],&tt[i]);
        p[i]/=100;
    }
    dp[0][0]=1;
    double ans=0.0;
    for(int i=1;i<=n;i++)
    {
        double sum=0;
        double kth=kasumi(1-p[i],tt[i]-1);
        for(int j=1;j<=t;j++)
        {
            sum*=1-p[i];
            sum+=dp[i-1][j-1]*p[i];
            if(j>=tt[i])
            {
                sum-=dp[i-1][j-tt[i]]*kth*p[i];
                dp[i][j]+=dp[i-1][j-tt[i]]*kth;
            }
            dp[i][j]+=sum;
            ans+=dp[i][j];
        }
    }
    printf("%.6lf
",ans);
}
 
原文地址:https://www.cnblogs.com/stxy-ferryman/p/9571208.html